<% # TODO Remove this out of here! %>
<% begin %>
  <% ej_component = Decidim::Component.find_by(id: properties[:ej_component_id]) %>
  <% if ej_component.present? %>
    <% ej_component_router = Decidim::EngineRouter.main_proxy(ej_component) %>
    <% api_client ||= Decidim::Ej::Connector::Client.new(ej_component.settings[:host], current_user) %>
    <% @conversation = api_client.fetch_conversation(ej_component.settings[:conversation_id]) %>
    <% @comment = api_client.fetch_next_comment(ej_component.settings[:conversation_id]) %>
    <% @user_participation_ratio = @conversation[:user_stats][:participation_ratio].to_f * 100.0 %>
  <% end %>
<% rescue StandardError => e %>
  <% @conversation = nil %>
  <% @comment = nil %>
  <% @user_participation_ratio = 0.0 %>
  <%= content_tag :script do %>
    console.log("Ocorreu um erro ao carregar os dados: <%= j e.message %>");
  <% end %>
<% end %>
<% # -------- %>

<%= stylesheet_pack_tag "decidim_ej", media: "all" %>

<div class="ej-survey-background">
  <% if current_user.present? %>
    <div class="br-container-lg mt-4 mb-4">
      <div id="ej-conversation" class="ej-component-container">
        <% if properties["survey_ended"] == "1" %>
          <div class="survey_ended_warning">
            <i class="fa-solid fa-circle-exclamation"></i>
            Esta enquete foi encerrada<%= properties['end_date'] ? " em " + properties['end_date'] : ""%>.
          </div>
        <% end %>
        <div class="ej-conversation-header">
          <h1 class="ej-conversation-header__title">
            <%= @conversation ? @conversation['text'] : "" %>
          </h1>
        </div>

        <% if false && @conversation['participants_can_add_comments'] %>
          <button id="add-new-comment-ej" class="br-button secondary black-and-white-btn" onclick="toggleCommentForm()">
            <i class="fa fa-plus"></i>
            <span>Adicionar comentário à enquete</span>
          </button>
        <% end %>

        <div class="ej-conversation-container">
          <% if @conversation && @conversation['user_stats'] %>
            <div class="percentage-container">
              <h4 class="percentage-title">Você respondeu <%= number_to_percentage(@user_participation_ratio, precision: 2) %> desta enquete</h4>
              <div style="background: var(--pure-0);">
                <div class="percentage-bar" style="width: <%= @user_participation_ratio %>%;"></div>
              </div>
            </div>
          <% end %>
          <div class="ej-conversation-card">
            <% if @comment && @comment['content'].present? %>
              <span>
                <% if @conversation && @conversation['user_stats'] %>
                  <div class="ej-conversation-card__comments">
                    Comentário <%= @conversation['user_stats']['comments'] %> de <%= @conversation['user_stats']['total_comments'] %>
                  </div>
                <% end %>
                <h3 id="comment-content" class="ej-conversation-card__comment">
                  <%= @comment['content'] %>
                </h3>
              </span>
              <div class="ej-conversation-card__votes">
                <button class="br-button primary" onclick="saveVote('agree', <%=  @comment['links']['self'].split('/')[-1]%>)" id="agree">
                  <span id="agree-text">
                    Concordo
                  </span>
                  <i class="fa fa-thumbs-up"></i>
                  <span id="agree-loader" class="loader"></span>
                </button>
                <button class="br-button primary" onclick="saveVote('disagree', <%=  @comment['links']['self'].split('/')[-1]%>)" id="disagree">
                  <span id="disagree-text">
                    Discordo
                  </span>
                  <i class="fa fa-thumbs-down"></i>
                  <span id="disagree-loader" class="loader"></span>
                </button>
                <button class="br-button secondary" onclick="saveVote('skip', <%=  @comment['links']['self'].split('/')[-1]%>)" id="skip">
                  <span id="skip-text">pular</span>
                  <span id="skip-loader" class="loader"></span>
                </button>
              </div>
            <% else %>
              <% if @user_participation_ratio > 0 %>
                <div>
                  <h3 class="ej-conversation-card__comment">
                    Parabéns! Você concluiu seus votos nesta enquete.
                  </h3>
                  <p>
                    Esta enquete está encerrada.
                  </p>
                </div>
              <% else %>
                <div>
                  <h3 class="ej-conversation-card__comment">
                    Você não participou desta enquete.
                  </h3>
                </div>
              <% end %>
            <% end %>
          </div>
        </div>

        <% if properties['has_surveys_list_button'] == "1" %>
          <div class="centered-content">
            <%= link_to ej_component_router.ej_index_path, class: "br-button primary" do %>
              <span class="mr-2">Acessar lista de enquetes</span>
              <i class="fa fa-arrow-right"></i>
            <% end %>
          </div>
        <% end %>
      </div>

      <% if @conversation['statistics'] %>

        <div class="bp-divider margin-top-2"></div>

          <% if properties["survey_ended"] == "1" %>
            <h3>Confira os resultados</h3>
          <% end %>
        <div class="ej-conversation__general-stats">


          <% if @conversation && @conversation['statistics']['participants']['voters'] %>
            <div class="ej-conversation-stats__card">
              <i class="fa fa-users fa-2x"></i>
              <div class="ej-conversation-stats__card-content">
                <span class="ej-stats__number">
                  <%= @conversation['statistics']['participants']['voters'] %>
                </span>
                <span class="ej-stats__description">
                  pessoas estão participando desta enquete
                </span>
              </div>
            </div>
          <% end %>
          <% if @conversation && @conversation['statistics']['votes']['total'] %>
            <div class="ej-conversation-stats__card">
              <i class="fa fa-vote-yea fa-2x"></i>
              <div class="ej-conversation-stats__card-content">
                <span class="ej-stats__number">
                  <%= @conversation['statistics']['votes']['total'] %>
                </span>
                <span class="ej-stats__description">
                  votos foram efetuados nesta enquete
                </span>
              </div>
            </div>
          <% end %>
          <% if @conversation && @conversation['statistics']['votes'] %>
            <% votes = @conversation['statistics']['votes'] %>
            <% agree_percentage = (votes['agree'].to_f / votes['total'] * 100).round(2) %>
            <% disagree_percentage = (votes['disagree'].to_f / votes['total'] * 100).round(2) %>
            <% skip_percentage = (votes['skip'].to_f / votes['total'] * 100).round(2) %>

            <div class="ej-conversation-stats__card ej-pie-chart-card">
              <div class="pie-chart-container">
                <div 
                  class="pie"
                  style="
                    width: 74px; 
                    height: 74px; 
                    background-image: conic-gradient(
                      #7FB135 <%= agree_percentage %>%, 
                      #FB5A47 <%= agree_percentage %>%, 
                      #FB5A47 <%= (agree_percentage + disagree_percentage) %>%, 
                      #FFC107 <%= (agree_percentage + disagree_percentage) %>%
                    );
                    border-radius: 50%;
                  ">
                </div>
                <div class="votes-info">
                  <div class="vote-row">
                    <i class="fa fa-thumbs-up"></i>
                    <span class="ej-stats__description"><%= agree_percentage %>% (<%= votes['agree'] %>)</span>
                  </div>
                  <div class="vote-row">
                    <i class="fa fa-thumbs-down"></i>
                    <span class="ej-stats__description"><%= disagree_percentage %>% (<%= votes['disagree'] %>)</span>
                  </div>
                </div>
              </div>
            </div>
          <% end %>
        </div>
      <% end %>

    </div>
  <% else %>
    <div class="br-scrim-util foco" id="scrimutilexample" data-scrim="true">
      <div class="br-modal" aria-labelledby="titulomodalexemplo">
        <div class="br-modal-header" id="titulomodalexemplo">Login obrigatório</div>
        <div class="br-modal-body">
          <p>Você precisa estar logado na plataforma para participar da enquete. Clique em 'Continuar' para acessar a tela de login.</p>
        </div>
        <div class="br-modal-footer justify-content-center">
          <button class="br-button secondary" id="scrimfechar" type="button" data-dismiss="true">Cancelar
          </button>
          <a href="/users/sign_in" class="br-button primary mt-3 mt-sm-0 ml-sm-3" type="button">Continuar
          </a>
        </div>
      </div>
    </div>
    <div class="br-container-lg mt-4 mb-4">
      <div id="ej-conversation" class="ej-component-container">
        <div class="ej-conversation-header">
          <h1 class="ej-conversation-header__title">
            <%= properties['text'] %>
          </h1>
        </div>

        <div class="ej-conversation-container">
          <div class="percentage-container">
            <h4 class="percentage-title">Você respondeu 0% desta enquete</h4>
            <div style="background: var(--pure-0);">
              <div class="percentage-bar" style="width: 0%;"></div>
            </div>
          </div>
          <div class="ej-conversation-card">
              <span>
                <div class="ej-conversation-card__comments">
                  Comentário 0 de <%= properties['comments_number'] %>
                </div>
                <h3 id="comment-content" class="ej-conversation-card__comment">
                  <%= properties['first_comment'] %>
                </h3>
              </span>
              <div class="ej-conversation-card__votes scrimutilexemplo">
                <button class="br-button primary" id="agree">
                  <span id="agree-text">
                    Concordo
                  </span>
                  <i class="fa fa-thumbs-up"></i>
                  <span id="agree-loader" class="loader"></span>
                </button>
                <button class="br-button primary" id="disagree">
                  <span id="disagree-text">
                    Discordo
                  </span>
                  <i class="fa fa-thumbs-down"></i>
                  <span id="disagree-loader" class="loader"></span>
                </button>
                <button class="br-button secondary" id="skip">
                  <span id="skip-text">Pular</span>
                  <span id="skip-loader" class="loader"></span>
                </button>
              </div>
          </div>
        </div>

        <% if properties['has_surveys_list_button'] == "1" %>
          <div class="centered-content">
            <%= link_to ej_component_router.ej_index_path, class: "br-button primary" do %>
              <span class="mr-2">Acessar lista de enquetes</span>
              <i class="fa fa-arrow-right"></i>
            <% end %>
          </div>
        <% end %>
      </div>
    </div>
  <% end %>
</div>


<% if ej_component.present? %>
<script>
(function() {
  const saveVote = (choice, comment_id) => {
    const url_formatted = "<%= ej_component_router.post_vote_ej_url(ej_component.settings[:conversation_id]) %>";
    const new_url = url_formatted.replace('http://','https://');

    $.ajax({
      method: "POST",
      url: new_url,
      data: {"choice": choice, "comment_id": comment_id},

      beforeSend: function() {
        $(`#${choice}-text`).hide();
        $(`#${choice}-loader`).css("display", "block");
      },
      success: function(response) {
        $(`#${choice}-text`).show();
        $(`#${choice}-loader`).hide();
        $("#ej-conversation").replaceWith(response);
      }
    });
  };
  window.saveVote = saveVote;

  const toggleCommentForm = () => {
    $("#comment-div-form").toggle(200, function() {
      const button = $("#add-new-comment-ej");
      const icon = button.find("i");
      const span = button.find("span");

      if ($("#comment-div-form").is(":visible")) {
        icon.removeClass("fa-plus").addClass("fa-minus");
        span.text("Cancelar comentário à enquete");
      } else {
        icon.removeClass("fa-minus").addClass("fa-plus");
        span.text("Adicionar comentário à enquete");
      }
    });
  };
  window.toggleCommentForm = toggleCommentForm;
})();
</script>
<% end %>

